/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_PLACE_NAME_H__
#define __MTK_PLACE_NAME_H__
#include  <vector>
#include  "../common/graphics/wgl_font.h"
#include  "../common/graphics/topograph.h"
#include  "../common/bilingual.h"
using namespace std;


//-------
//  
//-------
enum {
	PNSTATE_ON,
	PNSTATE_OFF,
	PNSTATE_FLUSH
};


//-----------
//  n
//-----------
struct  PlaceNameItem
{
	float lon, lat;					// oAk
	bilingual  bszName;				// O
	float	R1, R2;					// \p̔a
	char	group;					// O[v
	char	ty;						// 
	char	align;					// 
	char	state;					// 
	float	size;					// ̃TCY
	float	alp;					// x
	float	label_alp;				// ̓x
	bool	bDispLabel;				// \邩
};


//-----------------------
//  [r[p̃GtFNg
//-----------------------
enum {
	PNEFFECT_NORMAL,
	PNEFFECT_BLINK,
	PNEFFECT_FADEIN,
	PNEFFECT_FADEOUT,
	PNEFFECT_ENABLE_LABEL,
	PNEFFECT_DISABLE_LABEL,
	PNEFFECT_FADEIN_LABEL,
	PNEFFECT_FADEOUT_LABEL
};

struct pn_effect {
	int		frame1, frame2;	// GtFNg̊JnƏIt[
	char	ty;			//@GtFNg̎
	char	group;		//  KpO[v
};



//-------------
//  PlaceName
//-------------
class  PlaceName
{
private:
	vector<PlaceNameItem>	vPlace;
	vector<pn_effect>		vEffect;
public:
	void  clear()	{ vPlace.clear(); }
	void  add_place(const PlaceNameItem& pni);
	void  set_state(char group, char state);
	void  set_alpha(char group, float alp);
	void  set_label_alpha(char group, float alp);
	void  enable_label(char group, bool bDispLabel);
	void  add_effect(const pn_effect& pnef)		{ vEffect.push_back(pnef); }
	void  clear_effect()						{ vEffect.clear(); }
	void  evalutate_effect(float t);
	void  draw_on_TopoSphere(const TopoSphere& tp, float screen_w, float screen_z, wgl_font& fnt, bool bEng, float ltf)  const;
private:
	void  draw_pointer(const TopoSphere& tp, const PlaceNameItem& pni, const float& af) const;
};



//--------------
//  n\|C^
//--------------
void	draw_pointer_on_TopoSphere(const TopoSphere& tp, float screen_w, float screen_z, wgl_font& fnt,   float lon, float lat, float ltf);
void	draw_pointer_on_sphere(float screen_w, float screen_z, wgl_font& fnt,   float lon, float lat, float ltf);


#endif
