/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  "mtk_planetary_ring.h"
#include  "../common/astro/cele_mech.h"


const double pi = 3.141592653;


//-------------------
//  Planetary Rings
//-------------------

// a͘f̔aŋKi
particle_ring::particle_ring(float _R1, float _R2) : R1(_R1), R2(_R2)
{
	for (int i=0; i<particle_ring_RN; i++) {
		s[i] = float(i)/(particle_ring_RN-1);
		const float r = (R2-R1) * float(i) / (particle_ring_RN-1) + R1;

		for (int j=0; j<=particle_ring_PHIN; j++) {
			const float phi  = 2*pi * float(j)/particle_ring_PHIN;

			float x, y;
			x = r *cosf(phi);
			y = r *sinf(phi);

			pos[i][j].set(x,y,0.0f);
		}
	}

}


// fSɈړBf̔aŃXP[OBf̐ԓW
void
particle_ring::draw()  const
{
	float frac[particle_ring_RN][particle_ring_PHIN+1];


	float lp[4];
	glGetLightfv(GL_LIGHT0, GL_POSITION, lp);	// _Wnł̌̈ʒu
	const vector3f lv_e = normalize(vector3f(lp[0], lp[1], lp[2]));	// s



	float M[16];
	glGetFloatv(GL_MODELVIEW_MATRIX,  M);


    // x̌vZ
	for (int i=0; i<particle_ring_RN; i++) {
		for (int j=0; j<=particle_ring_PHIN; j++) {
			const vector3f&  pos_pl = pos[i][j];

			float x, y;
			x = pos_pl.x;
			y = pos_pl.y;

			// _Wnł̗vf̈ʒuxNg
			vector3f  pos_e;
			pos_e.x = M[0]*x + M[4]*y + M[12];
			pos_e.y = M[1]*x + M[5]*y + M[13];
			pos_e.z = M[2]*x + M[6]*y + M[14];

			// xvZ
			const vector3f nv = normalize(-pos_e);
			float dp = dot_product(lv_e, nv);		// s
			float th = acosf(dp);

			frac[i][j] = 1.0 - th / pi;
		}
	}


	// `
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDisable(GL_CULL_FACE);


	for (int i=0; i<particle_ring_RN-1; i++) {
		glBegin(GL_TRIANGLE_STRIP);
		for (int j=0; j<particle_ring_PHIN; j++) {
			float f;

			f = frac[i][j];
			glColor3f(f,f,f);
			glTexCoord2f(s[i], 0);
			glVertex3fv(pos[i][j].get_pointer());

			f = frac[i+1][j];
			glColor3f(f,f,f);
			glTexCoord2f(s[i+1], 0);
			glVertex3fv(pos[i+1][j].get_pointer());

			f = frac[i][j+1];
			glColor3f(f,f,f);
			glTexCoord2f(s[i], 0);
			glVertex3fv(pos[i][j+1].get_pointer());

			f = frac[i+1][j+1];
			glColor3f(f,f,f);
			glTexCoord2f(s[i+1], 0);
			glVertex3fv(pos[i+1][j+1].get_pointer());
		}
		glEnd();
	}
	glPopAttrib();
}
