/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_PLANETS_H__
#define __MTK_PLANETS_H__
#include  "../common/win_file.h"
#include  "mtk_place_name.h"
#include  "mtk_draw_struct.h"
#include  "../common/graphics/color.h"
#include  "mtk_space_curve.h"


//-----------
//  Defines
//-----------
struct zoom_rate {
	double zmhPlanet, zmhSun, zmhMoonOrb;		// 3D[hł̊g嗦
	double zmpPlanet, zmpSunMoon;				// vl^E[hł̊g嗦
};


//-------------
//  Constants
//-------------
const float R_sun_km  = 696000;
const float R_moon_km = 1738.092;


//-------------
//  Functions
//-------------
void	register_solar_system_objects();


//--  Orbit  --
float	get_sun_label_alpha(const mtk_draw_struct& ds);
void	register_planets_orbit_curves();
void	make_planets_orbit_curve(space_curve& sc, int div_N);
float	get_planet_label_alpha(const mtk_draw_struct& ds, int idx);
float	get_planet_orbit_alpha(const mtk_draw_struct& ds, int idx);
void	register_satellites_orbit_curves();
void	make_satellites_orbit_curve(space_curve& sc, double t, int div_N);
void	set_satellites_orbit_curve(space_curve& sc, double t);
float	get_satellite_label_alpha(const mtk_draw_struct& ds, int idx);
float	get_satellite_orbit_alpha(const mtk_draw_struct& ds, int idx);

bool	is_satellite_selected(int idx);

double	calc_visible_radius_planet(int idx);
double	calc_visible_radius_satellite(int idx);

void	draw_sun(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl);
void	draw_a_planet_3D(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl);
void	draw_a_satellite(const mtk_draw_struct& ds, int idx, const vector3d& rpos, double scl);

void	set_light_from_sun(const vector3d& pos);

zoom_rate	get_zoom_rate();
void	set_zoom_mode(char mode);
char	get_zoom_mode();
void	set_topo_zoom_mode(char mode);
char	get_topo_zoom_mode();

void	load_solar_system_textures();
void	load_earth_topograph(directory& dir, const char* filename);
void	load_mars_topograph(directory& dir, const char* filename);

void	set_object_orientation(const double& alp, const double& dlt, const double& W);
void	set_planet_orientation(int idx);
void	set_planet_light(int idx);
void	set_light_from_sun(const vector3d& pos);

void	draw_planet2(int idx);

double	get_sun_radius();
double	get_sun_glare_radius();

void	draw_sun0(const float& R, const RGBf& col);


//*******
void	draw_planets_planetarium(const mtk_draw_struct& ds);
void	draw_moon_planetarium(const mtk_draw_struct& ds);



#endif
