/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mitaka.h"
#include  "mtk_target.h"
#include  "../common/astro/astro_const.h"
#include  "mtk_planets.h"
#include  "mtk_planet_position.h"
#include  "mtk_planet_orientation.h"
#include  "mtk_planet_phys_params.h"
#include  "mtk_minor_planets.h"
#include  "mtk_stars.h"
#include  "mtk_spacecraft.h"
#include  "mtk_camera.h"



//-----------
//  Externs
//-----------
extern mtk_camera	g_camera;
extern vector3f		GC;
extern TopoSphere	tpEarth, tpMars;
extern float landing_lon, landing_lat;
extern char  tyMode;


vector2d	get_landing_pos();


char  tyTarget	= TGTNO_EARTH;		// ^[Qbg
static vector3d  target_pos0;		//  Target ̒SʒuiSWAPpcj
static vector3d  target_pos;		//  J̃^[Qbg



//------------
//  ^[Qbg
//------------
mtk_target  targets[] = {
	{ TGTCLS_NONE,		0, 0, 0,		1 },		// No target
	{ TGTCLS_SUN,		0, 0, 0,		1 },		// Sun
	{ TGTCLS_PLANET,	0, 0, 0,		1 },		// Mercury
	{ TGTCLS_PLANET,	0, 1, 0,		1 },		// Venus
	{ TGTCLS_PLANET,	0, 2, 0,		1 },		// Earth
	{ TGTCLS_PLANET,	0, 3, 0,		1 },		// Mars
	{ TGTCLS_PLANET,	0, 4, 0,		1 },		// Jupiter
	{ TGTCLS_PLANET,	0, 5, 0,		1 },		// Saturn
	{ TGTCLS_PLANET,	0, 6, 0,		1 },		// Uranus
	{ TGTCLS_PLANET,	0, 7, 0,		1 },		// Neptune
	{ TGTCLS_PLANET,	0, 8, 0,		1 },		// Pluto
	{ TGTCLS_SMALL_OBJECT,	136199, 0, 0,	1 },	// Eris
	{ TGTCLS_SMALL_OBJECT,	90377, 1, 0,	1 },	// Sedna

	{ TGTCLS_SATELLITE,	SAT_MOON, 0, 0,		1 },		// Moon
	{ TGTCLS_SATELLITE,	SAT_IO, 1, 0,		1 },		// IO

	{ TGTCLS_PROBE,		0, 0, 0,		100 * 100.0 * _1km_pc },		// Pioneer10
	{ TGTCLS_PROBE,		1, 0, 0,		100 * 100.0 * _1km_pc },		// Pioneer11
	{ TGTCLS_PROBE,		2, 0, 0,		100 * 100.0 * _1km_pc },		// Voyager I
	{ TGTCLS_PROBE,		3, 0, 0,		100 * 100.0 * _1km_pc },		// Voyager II
	{ TGTCLS_PROBE,		4, 0, 0,		100 * 100.0 * _1km_pc },		// Cassini
	{ TGTCLS_STAR,		0, 0, 71683,	0.7 },		// Alpha Centauri
	{ TGTCLS_STAR,		0, 1, 32349,	10  },		// Sirius
	{ TGTCLS_STAR,		0, 2, 17702,	50 },		// Subaru (Atlas)
	{ TGTCLS_STAR,		0, 3, 36850,	50 },		// Castor
	{ TGTCLS_FIXED,		0, 0, 0,		200 },		// M13
	{ TGTCLS_FIXED,		1, 0, 0,		1e5 },		// Our Galaxy Center
	{ TGTCLS_FIXED,		2, 0, 0,		2.62e5 },	// Our Galaxy
	{ TGTCLS_FIXED,		3, 0, 0,		1.3e6 },	// Andromeda Galaxy
	{ TGTCLS_FIXED,		4, 0, 0,		2.18e7 },	// Virgo Cluster (M87)
	{ TGTCLS_FIXED,		5, 0, 0,		3.80e9 }	// Large Scale Structure
};
const int targetN = sizeof(targets)/sizeof(mtk_target);



const int fixed_target_N = 6;
vector3d  fixed_target_pos[6] = {
	vector3d(0,0,0),
	GC,
	vector3d(0,0,0),
	vector3d(5.20e5, 2.66e5, 3.85e5),
	vector3d(-1.659e7,-5.96e5,4.278e6),
	vector3d(0,0,0)
};

const int goto_command_target[] = {
	TGTNO_EARTH,
	TGTNO_CASSINI,
	TGTNO_SUBARU,
	TGTNO_M13,
	TGTNO_OUR_GALAXY_CENTER,
	TGTNO_VIRGO_CLUSTER
};

double
get_target_ini_scale(int tgt_no)
{
	// XP[ݒ
	const mtk_target&  tgt = get_target(tgt_no);
	const zoom_rate zr = get_zoom_rate();

	double ini_scale = 0.0;
	switch (tgt.cls) {
		case TGTCLS_SUN:
			ini_scale = 2.0 * _1AU_pc * zr.zmhSun;
			break;
		case TGTCLS_PLANET:
			ini_scale = get_planet_Re(tgt.id2) * _1km_pc * 30.0;
			break;
		case TGTCLS_SATELLITE:
			{
				double Rx, Ry, Rz;
				get_satellite_size(tgt.id1, Rx, Ry, Rz);
				ini_scale = Rx * 30.0 * _1km_pc;
			}
			break;
		case TGTCLS_SMALL_OBJECT:
			{
				ini_scale = 1000 * _1km_pc * 30;
			}
			break;
		case TGTCLS_COMET:
		case TGTCLS_PROBE:
		case TGTCLS_STAR:
		case TGTCLS_FIXED:
			ini_scale = tgt.ini_scale;
			break;
		default:
			break;
	}

	return  ini_scale;
}



//
//
//
const mtk_target&
get_current_target()
{
	return targets[tyTarget];
}

const mtk_target&
get_target(int idx)
{
	return targets[idx];
}


int
get_goto_command_target_no(int idx)
{
	return goto_command_target[idx];
}



//--------------
//  Target pos
//--------------
const vector3d&
get_target_center_pos()
{
	return  target_pos0;
}

const vector3d&
get_current_target_pos()
{
	return  target_pos;
}

void
set_target_pos(const vector3d& pos)
{
	target_pos0 = pos;
	target_pos  = target_pos0;
}




//-------------------------
//  Target Radius (in pc)
//-------------------------
float
get_target_radius()
{
	float R;

	//***
	const mtk_target&  tgt = get_current_target();
	if (tyMode == MODE_HIPPARCOS) {
		switch (tgt.cls) {
			case TGTCLS_SUN:
				R = R_sun_km * _1km_pc * get_zoom_rate().zmhSun;
				break;
			case TGTCLS_PLANET:
				R = get_planet_Re(tgt.id2) * _1km_pc;
				break;
			case TGTCLS_SATELLITE:
				{
					double Rx, Ry, Rz;
					get_satellite_size(tgt.id1, Rx, Ry, Rz);
					R = Rx * _1km_pc;
				}
				break;
			case TGTCLS_SMALL_OBJECT:
				R = 2000 * _1km_pc;
				break;
			default:
				R = 0;
				break;
		}
	} else {
		switch (tgt.cls) {
			case TGTCLS_SUN:
				R = R_sun_km * _1km_pc;
				break;
			case TGTCLS_PLANET:
				R = get_planet_Re(tgt.id2) * _1km_pc;
				break;
			case TGTCLS_SATELLITE:
				{
					double Rx, Ry, Rz;
					get_satellite_size(tgt.id1, Rx, Ry, Rz);
					R = Rx * _1km_pc;
				}
				break;
			default:
				R = 0;
				break;
		}
	}

	return  R;
}




//-------------------
//  Adjust Position
//-------------------
void
adjust_target_position()
{
	const mtk_target&  tgt = get_current_target();
	double R = get_target_radius();


	if (tyMode == MODE_HIPPARCOS) {
		if (tgt.cls == TGTCLS_PLANET && (tgt.id2==2 || tgt.id2==3)) {
			vector2d  lon_lat = get_landing_pos();
			if (tgt.id2==2 && tpEarth.is_loaded()) {
				R += tpEarth.get_elv_fac() * tpEarth.get_elevation(lon_lat.x, lon_lat.y) * _1km_pc / 1000.0;
			} else if (tgt.id2==3 && tpMars.is_loaded()) {
				R += tpMars.get_elv_fac() * tpMars.get_elevation(lon_lat.x, lon_lat.y) * _1km_pc / 1000.0;
			}
		}

		vector3d eF, eU, eR;
		g_camera.get_axes(eF, eU, eR);
		target_pos = target_pos0 - R*eF;

	} else {

		if (tgt.cls == TGTCLS_PLANET) {
			if (tgt.id2==2 || tgt.id2==3) {
				if (tgt.id2==2 && tpEarth.is_loaded()) {
					R += tpEarth.get_elv_fac() * tpEarth.get_elevation(landing_lon, landing_lat) * _1km_pc / 1000.0;
				} else if (tgt.id2==3 && tpMars.is_loaded()) {
					R += tpMars.get_elv_fac() * tpMars.get_elevation(landing_lon, landing_lat) * _1km_pc / 1000.0;
				}
			}

			target_pos = target_pos0 + R * get_planet_nv_ec(tgt.id2, landing_lon, landing_lat);
		} else {
			target_pos = target_pos0;
		}
	}
}



//-------------------
//  Update Position
//-------------------
void
update_target_pos()
{
	const mtk_target& tgt = get_current_target();

	switch (tgt.cls) {
		case TGTCLS_SUN:
			set_target_pos( vector3d(0,0,0) );
			break;
		case TGTCLS_PLANET:
			set_target_pos( get_planet_position(tgt.id2) );
			break;
		case TGTCLS_SATELLITE:
			set_target_pos( get_satellite_position(tgt.id1) );
			break;
		case TGTCLS_SMALL_OBJECT:
			set_target_pos( get_small_object_position( get_small_object_index(tgt.id1) ) );
			break;
		case TGTCLS_PROBE:	//*** Spacecraft
			set_target_pos( get_spacecraft_position(tgt.id1) );
			break;
		case TGTCLS_STAR:
			{
				set_target_pos( get_star_position_by_HIP(tgt.id3) );
			}
			break;
		case TGTCLS_FIXED:
			set_target_pos( fixed_target_pos[tgt.id1] );
			break;
		case TGTCLS_NONE:
		default:
			break;
	}

	adjust_target_position();
}










